/*** InsertValues.cc ***/
//------------------------------------------------
// Author: Torsten Knorr
// E-mail: create-soft@freenet.de
// Copyright (c) 2015-2017, Torsten Knorr
//------------------------------------------------

 word GetDecValue(int i_length)
    {
    int  i_index;
    word w_value;
    char c_key_value;
    char ac_string[4];

    ac_string[0] = 0x00;
    ac_string[1] = 0x00;
    ac_string[2] = 0x00;
    ac_string[3] = 0x00;
    w_value      = 0x00;

    for(i_index = 0; i_index < i_length; i_index++)
        {
        switch(GetKey())
            {
            case KEY_1: c_key_value = '1'; break;
            case KEY_2: c_key_value = '2'; break;
            case KEY_3: c_key_value = '3'; break;
            case KEY_4: c_key_value = '4'; break;
            case KEY_5: c_key_value = '5'; break;
            case KEY_6: c_key_value = '6'; break;
            case KEY_7: c_key_value = '7'; break;
            case KEY_8: c_key_value = '8'; break;
            case KEY_9: c_key_value = '9'; break;
            case KEY_0: c_key_value = '0'; break;
            case KEY_X: i_index--;      continue;
            case KEY_H: i_index--;      continue;
            default:    i_index--;      continue;
            }

        ac_string[i_index] = c_key_value;

        LCD_WriteChar(c_key_value);
        Thread_Delay(100);
        }

    w_value = Str_ReadInt(ac_string);

    return w_value;
    }

//------------------------------------------------

 byte GetBCDValue(void)
    {
    word w_key;
    int i_count;
    byte by_bcd_value;
    byte by_key_value;

    by_bcd_value = 0x00;
    for(i_count = 4; i_count >= 0; i_count = i_count - 4)
        {
        switch(GetKey())
            {
            case KEY_1: by_key_value = 1; break;
            case KEY_2: by_key_value = 2; break;
            case KEY_3: by_key_value = 3; break;
            case KEY_4: by_key_value = 4; break;
            case KEY_5: by_key_value = 5; break;
            case KEY_6: by_key_value = 6; break;
            case KEY_7: by_key_value = 7; break;
            case KEY_8: by_key_value = 8; break;
            case KEY_9: by_key_value = 9; break;
            case KEY_0: by_key_value = 0; break;
            case KEY_X: i_count = 4 + i_count; continue;
            case KEY_H: i_count = 4 + i_count; continue;
            default:    i_count = 4 + i_count; continue;
            }

        by_bcd_value = by_bcd_value | (by_key_value << i_count);

        LCD_WriteChar(0x30 + by_key_value);
        Thread_Delay(100);

        }

    Thread_Delay(100);
    return by_bcd_value;
    }

//------------------------------------------------

 void InsertCmdAreas(void)
    {

    gby_cmd   = 0x00;

    while(1)
        {
        SET_DISPLAY_MOVE(
            "Insert areas of execution",
            "Remote=1 Local=2 Both=3",
            )

        switch(GetKey())
            {
            case KEY_1:
                gby_cmd = RFM12BP_REMOTE_CMD;
                SET_DISPLAY_MSG(" Remote ", "Command ", 100)
                break;

            case KEY_2:
                gby_cmd = RFM12BP_LOCAL_CMD;
                SET_DISPLAY_MSG(" Local  ", "Command ", 100)
                break;

            case KEY_3:
                gby_cmd = (RFM12BP_REMOTE_CMD | RFM12BP_LOCAL_CMD);
                SET_DISPLAY_MSG("  Both  ", "Command ", 100)
                break;

            case KEY_4:
            case KEY_5:
            case KEY_6:
            case KEY_7:
            case KEY_8:
            case KEY_9:
                SET_DISPLAY_ERROR(DISPLAY_UNDEF_KEY, 200)
                continue;

            case KEY_0:
                continue;

            case KEY_H:
                gi_menu++;
                MenuChange();
                return;

            case KEY_X:
                gi_menu--;
                MenuChange();
                return;

            default:
                SET_DISPLAY_ERROR(DISPLAY_OUT_OF_RANGE, 200)
                continue;
            }
        break;
        }
    }

//------------------------------------------------

 void InsertExeCmd(void)
    {
    char ac_string[9];

    InsertCmdAreas();

    gby_cmd = (gby_cmd | RFM12BP_EXE_CMD);

    SET_DISPLAY_INSERT("HighByte", " 000-255")
    gby_para_1 = (GetDecValue(3) & 0x00FF);
    Thread_Delay(100);

    SET_DISPLAY_INSERT("Low Byte", " 000-255")
    gby_para_2 = (GetDecValue(3) & 0x00FF);
    Thread_Delay(100);

    Str_Printf(ac_string, " 0x%2x%2x ", gby_para_1, gby_para_2);
    SET_DISPLAY_MSG("Command ", ac_string, 200)

    return;
    }

//------------------------------------------------

 void InsertSetTime(void)
    {
    byte aby_time[8];

// set year
    SET_DISPLAY_INSERT("Set Year", "20/00-99")
    aby_time[RTC_YEAR + 1] = GetBCDValue();

// set month
    SET_DISPLAY_INSERT("SetMonth", " 00-12  ");
    aby_time[RTC_MON + 1] = GetBCDValue();

// day of week = unused
    aby_time[RTC_DOW + 1] = 0x00;

// set day
    SET_DISPLAY_INSERT("Set Day ", " 00-31  ")
    aby_time[RTC_DAY + 1] = GetBCDValue();

// set hour
    SET_DISPLAY_INSERT("SetHours", " 00-24  ")
    aby_time[RTC_HOUR + 1] = GetBCDValue();

// set minutes
    SET_DISPLAY_INSERT("SetMinu.", " 00-60  ")
    aby_time[RTC_MIN + 1] = GetBCDValue();

// set seconds
    SET_DISPLAY_INSERT("SetSeco.", " 00-60  ")
    aby_time[RTC_SEC + 1] = GetBCDValue();

    aby_time[0] = RTC_SEC;
    if(!I2CTransmitData(RTC_ADDR, aby_time, 8, true))
        {
        SET_DISPLAY_MSG(" ERROR! ", "Set Time", 200)
        }

    SetSystemTime();
    SET_DISPLAY_MODE( DISPLAY_CLOCK )

    return;
    }

//------------------------------------------------

 void InsertExeFunction(void)
    {

    InsertCmdAreas();

    while(1)
        {
        SET_DISPLAY_MOVE(
            "Insert function number",
            "LDef=1 MRS=2 CRS=3 LEDS=4 LED1=5 LED2=6"
            )

        switch(GetKey())
            {
            case KEY_1:
                gby_cmd    = (gby_cmd | RFM12BP_LOAD_DEF);
                gby_para_1 = 0x00;
                gby_para_2 = 0x00;
                SET_DISPLAY_MSG("Function", "LoadDef.", 200)
                break;

            case KEY_2:
                gby_cmd    = (gby_cmd | RFM12BP_MODUL_RES);
                gby_para_1 = 0x00;
                gby_para_2 = 0x00;
                SET_DISPLAY_MSG("Function", "ModulRes", 200)
                break;

            case KEY_3:
                gby_cmd    = (gby_cmd | RFM12BP_COMPL_RES);
                gby_para_1 = 0x00;
                gby_para_2 = 0x00;
                SET_DISPLAY_MSG("Function", "ComplRes", 200)
                break;

            case KEY_4:
                gby_cmd    = (gby_cmd | TEST_LEDS);
                gby_para_1 = 0x00;
                gby_para_2 = 0x00;
                SET_DISPLAY_MSG("Function", "TestLEDS", 200);
                break;

            case KEY_5:
                gby_cmd    = (gby_cmd | TEST_LED_DEBUG_1);
                gby_para_1 = 0x00;
                gby_para_2 = 0x00;
                SET_DISPLAY_MSG("Function", "TestLED1", 200)
                break;

            case KEY_6:
                gby_cmd    = (gby_cmd | TEST_LED_DEBUG_2);
                gby_para_1 = 0x00;
                gby_para_2 = 0x00;
                SET_DISPLAY_MSG("Function", "TestLED1", 200)
                break;

            case KEY_7:
            case KEY_8:
            case KEY_9:
                SET_DISPLAY_ERROR(DISPLAY_UNDEF_KEY, 200)
                continue;

            case KEY_0:
                continue;

            case KEY_H:
                gi_menu++;
                MenuChange();
                return;

            case KEY_X:
                gi_menu--;
                MenuChange();
                return;

            default:
                SET_DISPLAY_ERROR(DISPLAY_OUT_OF_RANGE, 200)
                continue;
            }
        break;
        }

    return;
    }

//------------------------------------------------